/*
 *  Copyright (c) 2000-2003 Barak Weichselbaum <barak@komodia.com>
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Contact info:
 * -------------
 *
 * Site:					http://www.komodia.com
 * Main contact:			barak@komodia.com
 * For custom projects, 
 * consulting, or other
 * paid services:			sales@komodia.com
 */

#if !defined(AFX_SNIFFSOCKET_H__B694EA57_2BC0_483C_897E_80256AC3D059__INCLUDED_)
#define AFX_SNIFFSOCKET_H__B694EA57_2BC0_483C_897E_80256AC3D059__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SpoofSocket.h"
#include "AsyncSocket.h"

KOMODIA_NAMESPACE_START

class CSniffSocket : public CSpoofSocket,
					 public CAsyncSocket
{
public:
	//Create the socket
	BOOL Create();

	//Turn to be a sniffer socket
	virtual BOOL Sniff(BOOL bSniff);

	//Ctor and Dtor
	CSniffSocket();
	virtual ~CSniffSocket();
protected:
	//Get the socket handle
	virtual SOCKET GetAsyncHandle() const;

	//Go to async mode
	virtual BOOL SetAsync();

	//No default events
	NO_OnSocketTimeout
	NO_OnSocketConnect
	NO_OnSocketAccept
	NO_OnSocketClose
	NO_OnSocketOOB	
	NO_OnSocketWrite
private:
	//No copy Ctor
	CSniffSocket(const CSniffSocket& rSocket);

	//No assigment operator
	CSniffSocket& operator=(const CSniffSocket& rSocket);
};

KOMODIA_NAMESPACE_END

#endif // !defined(AFX_SNIFFSOCKET_H__B694EA57_2BC0_483C_897E_80256AC3D059__INCLUDED_)
